]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- avoid compressing very small (manual) pages
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gtkdocize            gtkdocize --copy
35 %__intltoolize          intltoolize --copy --force
36 %__libtoolize           libtoolize --copy --force
37
38 #       The number of cvs changelog entries kept when building package.
39 %_buildchangelogtruncate 20
40
41 %dependencytracking     %{nil}
42
43 #       Relations between package names that cause dependency loops
44 #       with legacy packages that cannot be fixed. Relations are
45 #       specified as
46 #               p>q
47 #       where package p has a Requires: on something that package q Provides:
48 #
49 # XXX   Note: that there cannot be any whitespace within the string "p>q",
50 #       and that both p and q are package names (i.e. no version/release).
51 %_dependency_whiteout   %{nil}
52
53 #-----------------------------------------------------------------
54 %configure2_13 { \
55  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
56  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
57  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
58  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
59  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
60  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
61  %{?__cc:CC="%{__cc}" ; export CC ; } \
62  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
63  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
64         --host=%{_target_platform} \
65         --prefix=%{_prefix} \
66         --exec-prefix=%{_exec_prefix} \
67         --bindir=%{_bindir} \
68         --sbindir=%{_sbindir} \
69         --sysconfdir=%{_sysconfdir} \
70         --datadir=%{_datadir} \
71         --includedir=%{_includedir} \
72         --libdir=%{_libdir} \
73         --libexecdir=%{_libexecdir} \
74         --localstatedir=%{_localstatedir} \
75         --sharedstatedir=%{_sharedstatedir} \
76         --mandir=%{_mandir} \
77         --infodir=%{_infodir} \
78         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
79         %{dependencytracking} \
80 }
81
82 %cmake { \
83 CC="%{__cc}" \
84 CXX="%{__cxx}" \
85 CFLAGS="%{rpmcflags}" \
86 CXXFLAGS="%{rpmcxxflags}" \
87 cmake \
88 }
89
90 #----------------------------------------------------------------
91 %global configure_cache 0
92 %configure_cache_file   %{buildroot}.configure.cache
93
94 %configure {./configure \
95         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
96         CFLAGS="${CFLAGS:-%rpmcflags}" \
97         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
98         FFLAGS="${FFLAGS:-%rpmcflags}" \
99         CPPFLAGS="${CPPFLAGS:-}" \
100         %{?__cc:CC="%{__cc}"} \
101         %{?__cxx:CXX="%{__cxx}"} \
102         --host=%{_target_platform} \
103         --build=%{_target_platform} \
104         --prefix=%{_prefix} \
105         --exec-prefix=%{_exec_prefix} \
106         --bindir=%{_bindir} \
107         --sbindir=%{_sbindir} \
108         --sysconfdir=%{_sysconfdir} \
109         --datadir=%{_datadir} \
110         --includedir=%{_includedir} \
111         --libdir=%{_libdir} \
112         --libexecdir=%{_libexecdir} \
113         --localstatedir=%{_localstatedir} \
114         --sharedstatedir=%{_sharedstatedir} \
115         --mandir=%{_mandir} \
116         --infodir=%{_infodir} \
117         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
118         %{dependencytracking} \
119         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
120 }
121
122 # ------------------------------------------------------------------------
123 # Overloading of some basic macros
124 %prep \
125 %%prep\
126 LANG=C\
127 export LANG\
128 unset DISPLAY ||:\
129 unset LINGUAS ||:\
130 %{nil}
131
132 %build %%build\
133 LANG=C\
134 export LANG\
135 unset DISPLAY ||:\
136 unset LINGUAS ||:\
137 %{nil}
138
139 %install \
140 %if 0%{?_enable_debug_packages}\
141 %{?buildsubdir:%{debug_package}}\
142 %endif\
143 %%install\
144 LANG=C\
145 export LANG\
146 unset DISPLAY ||:\
147 unset LINGUAS ||:\
148 %{nil}
149
150 # Location of autoconf macros
151 %_aclocaldir    %(aclocal --print-ac-dir)
152
153 # Location of omf files
154 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
155
156 # Location of pkgconfig files
157 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
158
159 # Location of desktop files
160 %_desktopdir    /usr/share/applications
161 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
162
163 # Location of pixmaps for applnk/desktop files
164 %_pixmapsdir    /usr/share/pixmaps
165
166 # Location of themable icons for applnk/desktop files
167 %_iconsdir      /usr/share/icons
168
169 # Location of fonts directories
170 %_fontsdir      /usr/share/fonts
171
172 # Location of Gtk and associated libraries documentation
173 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
174
175 # Location of KDE documentation
176 %_kdedocdir     %{_defaultdocdir}/kde/HTML
177
178 # unsermake script
179 %__unsermake /usr/share/unsermake/unsermake
180
181 # Current date
182 %date           %(LC_ALL="C" date +"%a %b %d %Y")
183
184 # tmp directory
185 %tmpdir         %(echo "${TMPDIR:-/tmp}")
186
187 # Example files, programs, scripts...
188 %_examplesdir   /usr/src/examples
189
190 # Alternative kernel type/version
191 %alt_kernel     %{nil}%{?_alt_kernel:-%{?_alt_kernel}}
192
193 # The directory holding Linux kernel sources
194 %_kernelsrcdir  /usr/src/linux%{alt_kernel}
195
196 # If non-empty "debug" macro defined, add "dbg" suffix to release number
197 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
198
199 # Requires name = version-release
200 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
201
202 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
203 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
204 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
205 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
206
207 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
208 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
209
210 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
211
212 # kernel version-release handling
213 %__kernel_ver   %([ -f %{_kernelsrcdir}/include/linux/version.h ] && (grep UTS_RELEASE %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
214 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
215 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
216 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
217 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
218
219 # sgml macros
220 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
221 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
222 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
223 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
224 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
225 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
226 %docbook_sgmlcat_fix() { for l in \
227 '' \
228 '  -- default decl --' \
229 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
230 '  -- hacks for opensp --' \
231 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
232 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
233 '' \
234 ; do echo $l; done >> %1 \
235 }
236
237 # minimum file size needed for compressed documents.
238 # just smaller files than this get larger when compressed.
239 # current number is based from experiment that 0 byte file compressed was 25 bytes .gz
240 %_min_compress_bytes    25
241
242 #-----------------------------------------------------------------
243 # find and gzip all files in %{_mandir} and %{infodir}
244 #
245 # Requires: xargs, find
246 #
247 #%no_install_post_compress_docs 1
248 %__spec_install_post_compress_docs { \
249 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
250         echo "Compress man and info pages."; \
251         for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
252                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
253                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
254                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
255                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
256                 fi; \
257         done; \
258 }; __spec_install_post_compress_docs } }
259
260 #-----------------------------------------------------------------
261 # Strip executable binaries and shared object files
262 #
263 # Requires: find, awk, strip, cut, xargs
264 #
265 #%no_install_post_strip 1
266 %__spec_install_post_strip {%{!?debug: \
267 %{!?no_install_post_strip:__spec_install_post_strip() { \
268         if [ -d "$RPM_BUILD_ROOT" ]; then \
269         echo "Strip executable binaries, archives and shared object files."; \
270         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
271         elfexelist=`echo $filelist | xargs -r file | \
272                 awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
273         elfsharedlist=`echo $filelist | xargs -r file | \
274                 awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
275         elfarchiveslist=`echo $filelist | xargs -r file | \
276                 awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
277         if [ -n "$elfexelist" ]; then \
278                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
279         fi; \
280         if [ -n "$elfsharedlist" ]; then \
281                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
282         fi; \
283         if [ -n "$elfarchiveslist" ]; then \
284                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $elfarchiveslist; \
285         fi; \
286 fi; }; __spec_install_post_strip } } }
287
288 #-----------------------------------------------------------------
289 # remove all RPATH from executable binaries and shared object files
290 #
291 # Requires: find, awk, cut, xargs, chrpath, uname
292 #
293 #%no_install_post_chrpath       1
294 %__spec_install_post_chrpath {%{!?debug: \
295 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
296 if [ -d "$RPM_BUILD_ROOT" ]; then \
297 echo "Remove RPATH from executable binaries and shared object files."; \
298 find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
299         awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1 | \
300 while read file ; do \
301         rpath= ; \
302         chmod u+w "$file"; \
303         for dir in `chrpath -l "$file" | \
304                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
305                         case $dir in \
306                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
307                                 echo "remove-rpath: $dir in $file"; \
308                                 ;; \
309                         * ) \
310                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
311                                 else rpath="$rpath:$dir" ; fi ; \
312                                 ;; \
313                         esac ; \
314         done ; \
315         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
316         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
317 done; \
318 fi; }; __spec_install_post_chrpath } } }
319
320 #-----------------------------------------------------------------
321 # Find and gzip all kernel modules
322 #
323 # Requires: find
324 #
325 #%no_install_post_compress_modules      1
326 %__spec_install_post_compress_modules { \
327 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
328         if [ -d "$RPM_BUILD_ROOT" ]; then \
329                 echo "Compress kernel modules if any."; \
330                 if test -d $RPM_BUILD_ROOT/lib/modules ; then \
331                         find $RPM_BUILD_ROOT/lib/modules -name \*o -type f -print | \
332                         xargs -r %{__gzip} -9nf; \
333                         find $RPM_BUILD_ROOT/lib/modules -name \*o -type l -printf "%p %l\n" | \
334                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
335                 fi; \
336         fi; \
337 }; __spec_install_post_compress_modules } }
338
339 # Remove common Perl files we don't package
340 %__spec_install_post_perl_clean {\
341 %{!?no_install_post_perl_clean: \
342 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
343 } }
344
345 #-----------------------------------------------------------------
346 # Update GConf2 schemas
347 #
348 # Requires: GConf2
349 #
350 %gconf_schema_install() \
351         umask 022; \
352         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
353         %{nil}
354
355 %gconf_schema_uninstall() \
356 if [ $1 = 0 ]; then \
357         umask 022; \
358         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
359 fi \
360 %{nil}
361
362 #-----------------------------------------------------------------
363 # Update desktop MIME database
364 # requires: desktop-file-utils
365 #
366 %update_desktop_database_post() {{ \
367         umask 022; \
368         /usr/bin/update-desktop-database; \
369 }}
370
371 %update_desktop_database_postun() {{ \
372 if [ $1 = 0 ]; then \
373         umask 022; \
374         /usr/bin/update-desktop-database; \
375 fi \
376 }}
377
378 #-----------------------------------------------------------------
379 # Update scrollkeeper database
380 # requires: scrollkeeper
381 #
382 %scrollkeeper_update_post() \
383         /usr/bin/scrollkeeper-update -q; \
384         %{nil}
385
386 %scrollkeeper_update_postun() \
387 if [ $1 = 0 ]; then \
388         /usr/bin/scrollkeeper-update -q; \
389 fi \
390 %{nil}
391
392 #-----------------------------------------------------------------
393 # post %install sequence:
394 # - autodeps exceptions
395 # - compress all man and info pages,
396 # - strip all ELF executables and ELF shared objects if not %debug.
397 # - compress kernel modules if any
398
399 ###################################################################
400 # Requires/Provides automation
401 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
402 #
403 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
404 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
405 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
406 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
407 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
408 #%_noautocompressdoc    %{nil}
409 #
410 %_missing_doc_files_terminate_build     1%{nil}
411 %_unpackaged_files_terminate_build      %{nil}
412 # (X)emacs support
413 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
414 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
415 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
416
417 %__php_provides %{nil}
418 %__php_requires %{nil}
419 %__perl_provides %{nil}
420 %__perl_requires %{nil}
421 %__mono_provides %{nil}
422 %__mono_requires %{nil}
423
424 # Perl specific macro definitions.
425 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
426 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
427 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
428 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
429 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
430 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
431
432 # Ruby
433 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
434 %ruby_ridir             %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
435 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
436 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
437 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
438 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
439 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
440 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
441
442 %php_pear_dir   %{_datadir}/pear
443
444 # directory where php includes are installed on system.
445 %__php_includedir               /usr/include/php
446 # extract php/zend api versions
447 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
448 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
449 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
450 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
451 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
452 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
453 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
454
455 # helper macro
456 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
457
458 # macros for public use
459 # for php extensions (php-pecl)
460 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
461 %{__php_api_requires -v %php_major_version debug php_debug} \
462 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
463
464 # for zend extensions
465 %requires_zend_extension %{__php_api_requires zend_module_api} \
466 %{__php_api_requires zend_extension_api} \
467 %{__php_api_requires -v %php_major_version debug php_debug} \
468 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
469
470 # for php pdo modules (php-pecl-PDO_*)
471 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
472
473 # Python specific macro definitions.
474 # python main version
475 %py_ver         %(python -c "import sys; print sys.version[:3]")
476
477 # directories
478 %py_prefix              %(python -c "import sys; print sys.prefix")
479 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
480 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
481 %py_incdir              /usr/include/python%{py_ver}
482 %py_sitedir     %{py_libdir}/site-packages
483 %py_sitescriptdir %{py_scriptdir}/site-packages
484 %py_dyndir              %{py_libdir}/lib-dynload
485
486 # pure python modules compilation
487 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
488
489 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
490
491 # Software written in Python language require Python with main version
492 %pyrequires_eq() Requires:      %1
493
494 # Hardlink binary identical .pyc and .pyo files
495 # (idea by glen <at> pld-linux <dot> org)
496 %__spec_install_post_py_hardlink {\
497 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
498 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
499         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
500         if cmp -s "$a" "$b"; then \
501                 ln -f "$a" "$b"; \
502         fi; \
503 done \
504 }; __spec_install_post_py_hardlink } }
505
506 # remove python sources, so that check-files won't complain
507 # (idea by glen <at> pld-linux <dot> org)
508 %py_postclean() \
509 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
510  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
511 done \
512 %{nil}
513
514 # depmod macro
515 %depmod() { \
516 umask 022; \
517 if [ -e /boot/System.map-%1 ]; then \
518         /sbin/depmod -a -F /boot/System.map-%1 %1; \
519 else \
520         if [ -e /boot/System.map ]; then \
521                 /sbin/depmod -a -F /boot/System.map %1; \
522         else \
523                 /sbin/depmod -a %1; \
524         fi \
525 fi; \
526 }
527
528 # XMMS specific macros
529 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
530 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
531 %xmms_version                   %(xmms-config --version 2>/dev/null)
532 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
533 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
534 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
535 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
536 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
537 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
538 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
539
540 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
541
542 # user/group checking macros
543 #
544 # Usage:
545 #       %userremove myuser
546 #
547 %userremove     /usr/lib/rpm/user_group.sh user del
548 %groupremove    /usr/lib/rpm/user_group.sh group del
549 #
550 # Usage:
551 #       if %usertestrm myuser; then
552 #               /usr/sbin/userdel -r myuser
553 # Note:
554 #       use these macros only if you need to call userdel/groupdel with
555 #       a non-standard option or take an extra action; otherwise use the
556 #       %userremove/%groupremove macros
557 #
558 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
559 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
560 # user group membership management macros
561 #
562 # Usage:
563 #       %addusertogroup myuser agroup
564 #
565 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
566
567 # banner support (useful in {pre,post}{,un} and triggers)
568 #
569 # Usage:
570 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
571 # the banner text, the banner text
572 # the banner text, and following line
573 #EOF
574 # You can use any form of here-document, <<'EOF' <<-EOT will do.
575 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
576 #
577 # -a   - append to the banner
578 # -e   - send to stderr instead of stdout
579 # -n   - no show banner (overrides -t)
580 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
581 %banner(aent:)  \
582 RPM_SCRIPTVERBOSITY=5 \
583 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
584 if [ -x /usr/bin/banner.sh ]; then \
585         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
586 else \
587         CMD="cat%{-e: >&2}" \
588 fi \
589 eval $CMD %2%{?3: %3} \
590 %nil
591
592 # useradd/groupadd macros written by glen@pld-linux.org.
593 # All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
594 #
595 # Usage:
596 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
597 #   [-g initial_group] [-G group[,...]] login
598 #
599 #  -u uid. REQUIRED
600 #  -g gid/group. REQUIRED
601 #  -s defaults to /bin/false
602 #  -d defaults to /usr/share/empty
603 #  -c No default
604 #  -r is accepted but ignored (it's always set)
605 #  -k skeleton dir. defaults to /usr/share/empty
606 # rpm specific flags
607 #  -P package name. defaults to %{name}
608 #
609 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
610 %{!-u:%{error:useradd: Required argument -u missing}} \
611 %{!-g:%{error:useradd: Required argument -g missing}} \
612 %{!?1:%{error:useradd: Required parameter login missing}} \
613 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
614         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
615                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
616                 exit 1 \
617         fi \
618 else \
619         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
620         /usr/sbin/useradd \\\
621                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
622                 -u %{-u*} \\\
623                 -r \\\
624                 -d %{-d*}%{!-d:/usr/share/empty} \\\
625                 -s %{-s*}%{!-s:/bin/false} \\\
626                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
627                 -g %{-g*} \\\
628                 %{-M} \\\
629                 %{-G:-G %{-G*}} \\\
630                 %{expand:%{%{#}}} 1>&2 || exit $? \
631         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd \
632 fi;
633
634 # Usage:
635 #   %groupadd [-P package] [-g gid] group
636 #
637 # -g gid. REQUIRED
638 #
639 # Sample:
640 #   %groupadd -P %{name}-base -g %{gid} %{name}
641
642 %groupadd(g:P:rfo)      \
643 %{!-g:%{error:groupadd: Required argument -g missing}} \
644 %{!?1:%{error:groupadd: Required parameter group missing}} \
645 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
646         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
647                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
648                 exit 1 \
649         fi \
650 else \
651         echo "Adding group %{1} GID=%{-g*}." \
652         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
653         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group \
654 fi;
655
656 # apache_config_{install/uninstall} macros written by glen@pld-linux.org.
657 # All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
658 #
659 # You should use webapp macros instead. these are here until single piece of them is gone from specs ;)
660 #
661 # The config is installed/removed inside trigger, this means that you can any
662 # time install apache1 or apache package and the configuration file is updated.
663 # if you don't need the config for various reason for specific apache, just
664 # remove the symlink from apache config directory. the trigger will not put the
665 # config again to that version of apache. In other words the config is linked
666 # to apache config directory on first install of PACKAGE or apache.
667 #
668 # should be called in trigger body:
669 #  %triggerin -- apache1 >= 1.3.33-2
670 #  %apache_config_install -v 1
671 #
672 # Add package's apache config to apache config.
673 #
674 # Usage:
675 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
676 #
677 #  -v REQUIRED: specify apache version. can be 1 or 2.
678 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
679 #  -n OPTIONAL: specify config "slot". defaults to 99
680 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
681 #
682 # Internal macros. don't use ;).
683 # expands apache config dir by apache version at build time.
684 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
685 # expands apache service name by apache version at build time.
686 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
687
688 %apache_config_install(fv:c:n:) \
689 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
690 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
691 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
692         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
693 fi\
694 # reload apache if the config symlink is there\
695 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
696         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
697         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
698                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
699         fi\
700 fi\
701 %{nil}
702
703 # Remove package's apache config from apache config.
704 #
705 # Usage:
706 #   %apache_config_uninstall -v {1|2} -n 99
707 #
708 #  -v REQUIRED: specify apache version. can be 1 or 2.
709 #  -n OPTIONAL: specify config "slot". defaults to 99
710 %apache_config_uninstall(v:n:) \
711 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
712 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
713 # remove link if either of the packages are gone \
714 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
715         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
716                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
717                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
718                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
719                 fi \
720         fi \
721 fi \
722 %{nil}
723
724 # webapp macros
725 #
726 # The config is installed/removed inside trigger, this means that you can any
727 # time install apache1/apache/lighttpd package and the configuration file is
728 # updated. if you don't need the config for various reason for specific
729 # webserver, just remove the symlink from config directory using webapp
730 # program. the trigger will not recreate the symlink on upgrades. In other
731 # words the config is linked to webserver config directory on first install of
732 # PACKAGE or WEBSERVER.
733 #
734 # Add package's webserver config to webserver webapps dir.
735 # Usage:
736 #   %webapp_register WEBSERVER WEBAPP
737 #
738 %webapp_register() \
739 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
740 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
741         /usr/sbin/webapp register %1 %2\
742 fi\
743 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
744 if [ -L /etc/%1/webapps.d/%2.conf ] && [ "$2" -lt "2" ]; then\
745         %{expand:%service -q %%1 reload}\
746 fi\
747 %{nil}
748
749 # Remove package's config from webserver webapps dir.
750 # Usage:
751 #   %webapp_register [-f] WEBSERVER WEBAPP
752 %webapp_unregister(f) \
753 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
754 # remove link if either of the packages are gone \
755 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%2.conf ]; then \
756         /usr/sbin/webapp unregister %1 %2\
757         %{expand:%service -q %%1 reload}\
758 fi \
759 %{nil}
760
761 # see browser-plugins.spec / template-browser-plugin.spec
762 # written by glen@pld-linux.org.
763 %nsplugin_install(d:f) { \
764 # create link if it's first install of either of the packages \
765 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
766 ( \
767 %( \
768         for file in %{*}; do \
769                 echo echo Installing $file to %{-d*}; \
770                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
771         done ) \
772 ) | ( %banner -t 5 -e %{name}-in ); fi; \
773 }
774
775 %nsplugin_uninstall(d:) { \
776 # remove link if either of the packages are gone \
777 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
778 ( \
779 %( \
780         for file in %{*}; do \
781                 echo echo Removing $file from %{-d*}; \
782                 echo "rm -f %{-d*}/$file;"; \
783         done ) \
784 ) | ( %banner -t 5 -e %{name}-un ); fi; \
785 }
786
787 # service macro.
788 #
789 # calls usual service restart on package %post, but skips the restart if
790 # administrator has disabled automatic service restarts in either global
791 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
792 #
793 # written by glen@pld-linux.org.
794 # All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
795 #
796 # Usage:
797 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
798 #
799 #  -q be silent when service isn't started (for scriplets restaring other package's services)
800 #
801 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
802
803
804 # java macros. based on jpackage macros.java
805 %_jvmdir                %{_libdir}/jvm
806 %_jvmjardir             %{_libdir}/jvm-exports
807 %_jvmprivdir            %{_libdir}/jvm-private
808 %_jvmlibdir             %{_libdir}/jvm
809 %_jvmdatadir            %{_datadir}/jvm
810 %_jvmsysconfdir         %{_sysconfdir}/jvm
811 # FIXME: are these used?
812 %_jvmcommonlibdir       %{_libdir}/jvm-common
813 %_jvmcommondatadir      %{_datadir}/jvm-common
814 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
815 %_jnidir                %{_libdir}/java
816 %java_home              %(unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo $JAVA_HOME)
817
818 %ant                    JAVA_HOME=%{java_home} ant
819 %jar                    %{java_home}/bin/jar
820 %java                   %(unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
821 %javac                  %{java_home}/bin/javac
822 %javadoc                %{java_home}/bin/javadoc
823
824 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
825
826 %jpackage_script() \
827 install -d $RPM_BUILD_ROOT%{_bindir}\
828 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
829 #!/bin/sh\
830 #\
831 # %{name} script\
832 # JPackage Project <http://www.jpackage.org/>\
833 \
834 # Source functions library\
835 . %{_javadir}-utils/java-functions\
836 \
837 # Source system prefs\
838 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
839     . %{_sysconfdir}/java/%{name}.conf\
840 fi\
841 \
842 # Source user prefs\
843 if [ -f $HOME/.%{name}rc ]; then\
844     . $HOME/.%{name}rc\
845 fi\
846 \
847 # Configuration\
848 MAIN_CLASS=%1\
849 BASE_FLAGS=%2\
850 BASE_OPTIONS=%3\
851 BASE_JARS="%(echo %4 | tr ':' ' ')"\
852 \
853 # Set parameters\
854 set_jvm\
855 set_classpath $BASE_JARS\
856 set_flags $BASE_FLAGS\
857 set_options $BASE_OPTIONS\
858 \
859 # Let's start\
860 run "$@"\
861 EOF
862
863 # pear install macros written by glen@pld-linux.org.
864 # All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
865 #
866 # Usage:
867 #       %%pear_package_setup [-a #] [-n FMT]
868 #
869 # -a #   - unpack SOURCE# instead of SOURCE0
870 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
871 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. use this for buggy packages.
872 # -f     - force pear install. use with care.
873 #
874 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
875 # destination hierarchy. you should copy the tree to buildroot after
876 # patching/reorganizing with %%pear_package_install.
877 #
878 # additionally BUILDROOT is stripped from files and files are converted to UNIX
879 # line endings.
880 #
881 # the pear install process output is recorded to install.log, you should put it
882 # to %%doc for latter debug or just information.
883 #
884 # additionally additional-packages.txt is produced if it was detected that the
885 # package has optional dependencies. the file format is suitable of displaying
886 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
887 # automatically added for this file.
888 #
889 %pear_package_setup(a:n:zf) \
890 %setup -q -c -T -n %{-n*}%{!-n:%{_pearname}-%{version}}\
891 D=%{_builddir}/%{-n*}%{!-n:%{_pearname}-%{version}} \
892 %{-z:tar zxf %{S:%{-a*}%{!-a:0}}; P=%{_pearname}-%{version}/package.xml; [ -f $P ] || P=package.xml} \
893 pear \\\
894         -d doc_dir=/docs \\\
895         -d php_dir=%{php_pear_dir} \\\
896         -d bin_dir=%{_bindir} \\\
897         -d data_dir=%{php_pear_dir}/data \\\
898         -d test_dir=%{php_pear_dir}/tests \\\
899         install \\\
900         --installroot=${D} \\\
901         --offline \\\
902         --nodeps \\\
903         %{-f:--force} \\\
904         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$P} | tee install.log \
905 # make post message of optional packages \
906 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
907 if [ -s optional-packages.txt ]; then \
908         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
909 else \
910         rm -f optional-packages.txt \
911 fi \
912 rm ./%{php_pear_dir}/.{lock,filemap} \
913 # undos sources \
914 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
915 # bug in PEAR --installroot. \
916 # http://pear.php.net/bugs/bug.php?id=5448 \
917 grep -rl "${D}" ./{%{_bindir},%{php_pear_dir}}/* | xargs -r sed -i -e "s,${D},," \
918 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
919 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
920 %{nil}
921
922 # copies exctracted PEAR package structure to buildroot.
923 # also copies PEAR registry file.
924 # please use this macro, for future extensions being possible.
925 %pear_package_install() \
926 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
927 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
928 # help the developer out a little: \
929 if [ -f _noautoreq ]; then \
930         echo "AutoReqdep detected:" \
931         echo "_noautoreq $(cat _noautoreq)" \
932 fi \
933 %{nil}
934
935
936 # Register OpenLDAP schema.
937 # Author: Elan Ruusamäe <glen@pld-linux.org>
938 #
939 # Usage:
940 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
941 #
942 #  -d specify dependant schemas, separated by comma
943 #
944 %openldap_schema_register(d:) \
945 for schema in %*; do \
946         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
947                 %{__sed} -i -e " \
948                         /^include.*local.schema/{ \
949                                 iinclude\\t     $schema\
950                         } \
951                 " /etc/openldap/slapd.conf \
952         fi \
953 done \
954 # enable dependant schemas \
955 if [ "%{-d*}" ]; then \
956         %{__sed} -i -e ' \
957         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
958                 s/^#// \
959         }' /etc/openldap/slapd.conf \
960 fi \
961 %{nil}
962
963 # Unregister OpenLDAP schema.
964 # Author: Elan Ruusamäe <glen@pld-linux.org>
965 #
966 # Usage:
967 #   %%openldap_schema_unregister %{schemadir}/horde.schema
968 #
969 %openldap_schema_unregister() \
970 for schema in %*; do \
971         if grep -q "$schema" /etc/openldap/slapd.conf; then \
972                 %{__sed} -i -e " \
973                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
974                 # for symmetry it would be nice if we disable enabled schemas in post, \
975                 # but we really can not do that, it would break something else. \
976                 " /etc/openldap/slapd.conf \
977         fi \
978 done \
979 %{nil}
980
981 # vim:ts=4 sw=4 noet
This page took 0.1723 seconds and 4 git commands to generate.